<?php
if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'before_widget' => '<li id="%1$s" class="widget %2$s">',
        'after_widget' => '</li>',
        'before_title' => '<h2 class="widgettitle">',
        'after_title' => '</h2>',
    ));
	
// Get Post Image
$thumn_path = ABSPATH . "wp-content/uploads/thumb/";
$prefix = "thumb_";

function get_post_image_list($image_number = 10,$thumb_width = 50,$thumb_height = 50,$type="recent") {
	global $wpdb;
	$sql = "SELECT ID, post_title, post_content FROM $wpdb->posts WHERE post_content LIKE ('%<img%') AND post_status = 'publish' AND post_type ='post' ";
	if($type=="recent"){
		$sql .= "ORDER BY post_date DESC ";
	}elseif($type=="random"){
		$sql .= "ORDER BY RAND() ";
	}
	$sql .= "LIMIT $image_number";
	
	$posts = $wpdb->get_results($sql);	
	
	if( $posts ) { 
		echo '<ul class="post-image-list">';
		foreach( $posts as $post ) {
			$content = $post-> post_content;
			
			preg_match_all('|<img.*?src=[\'"](.*?)[\'"].*?>|i', $post->post_content, $matches);			
			
			$img_src = $matches[1][0]; //first photo
			$img_name = get_img_name($img_src);
			$img_thumb = get_thumb_img($img_name);
			$img_link = str_replace(ABSPATH, get_settings('siteurl')."/", $img_thumb);

			@$fp = fopen($img_thumb,'r');  
			if   (!$fp && generate_thumb_image($img_src,$thumb_width,$thumb_height) == 0){
				$img = '<img src="' . $img_src . '" alt="'. wptexturize($post->post_title) . '" height="'.$thumb_height.'" />';
			} else {
				$img = '<img src="' . $img_link . '" alt="'. wptexturize($post->post_title) . '" />';
			}
			echo '<li><a href="'.get_permalink($post->ID).'" title="'. wptexturize($post->post_title).'">'. $img .'</a></li>';
		} 
		echo '</ul>';
	}
}
	
function generate_thumb_image($img_src, $thumb_width, $thumb_height){
	$img_name = get_img_name($img_src);
	$img_thumb = get_thumb_img($img_name);
	
	if(file_exists($img_thumb) ) {
        return 1;
	}
	
	list($im_width, $im_height, $type) = @getimagesize($img_src);
	
	switch ($type){
		case 1:
			$im = @imageCreateFromGIF($img_src);
			break;
		case 2:
			$im = @imageCreateFromJPEG($img_src);
			break;
		case 3:
			$im = @imageCreateFromPNG($img_src);
			break;
		default:
			return 0;
	}
	
	if($thumb_width == 0 && $thumb_height == 0){
		$thumb_height == 50;
		$thumb_width = $thumb_height / $im_height * $im_width;
	} elseif($thumb_width == 0){
		$thumb_width = $thumb_height / $im_height * $im_width;
	} elseif( $thumb_height == 0){
		$thumb_height = $thumb_width / $im_width * $im_height;
	}	
	
	$to = imagecreatetruecolor($thumb_width, $thumb_height);
    if(!$to) {
        return 0;
	}             
            
    if(!imagecopyresampled($to, $im, 0, 0, 0, 0, $thumb_width, $thumb_height, $im_width, $im_height)) {
        return 0;
    }

	switch ($type){
		case 1:
			imageGIF($to, $img_thumb);
			break;
		case 2:
			imageJPEG($to, $img_thumb);
			break;
		case 3:
			imagePNG($to, $img_thumb);
			break;
		default:
			return 0;
	}
	
	imageDestroy($im);
	
	return 1;
}

function get_thumb_img($img_name){
	global $thumn_path, $prefix;
	return $thumn_path.$prefix.$img_name;
}

function get_img_name($img_src){
	return substr($img_src,strrpos($img_src,"/")+1);
}

// Get New Comments
function get_new_comment_list() {

	global $wpdb;

	$sql = "SELECT DISTINCT ID, post_title, post_password, comment_ID,
comment_post_ID, comment_author, comment_date_gmt, comment_approved,
comment_type,comment_author_url,
SUBSTRING(comment_content,1,30) AS com_excerpt
FROM $wpdb->comments
LEFT OUTER JOIN $wpdb->posts ON ($wpdb->comments.comment_post_ID =
$wpdb->posts.ID)
WHERE comment_approved = '1' AND comment_type = '' AND
post_password = ''
ORDER BY comment_date_gmt DESC
LIMIT 10";

	$comments = $wpdb->get_results($sql);
	$output = $pre_HTML;

	$output .= "\n<ul class=\"sidelist\">";

	foreach ($comments as $comment) {
	$output .= "\n<li>". "<a href=\"" . get_permalink($comment->ID) .
"#comment-" . $comment->comment_ID . "\" title=\"发表于《".
$comment->post_title . "》\">" . strip_tags($comment->com_excerpt) ."</a></li>";}

	$output .= "\n</ul>";




	$output .= $post_HTML;

	echo $output;
}


// Get Comments' Members
function get_commentmembers($threshhold = 5) {
	global $wpdb, $tablecomments;
	$comments = $wpdb->get_results("SELECT comment_author, comment_author_url, COUNT(comment_ID) AS 'comment_total' FROM $tablecomments WHERE comment_approved = '1' AND (comment_author != 'ray1980') AND (comment_author != '')GROUP BY comment_author ORDER BY comment_total DESC");
	$no = 1;

    foreach ($comments as $comment) {
			$comment_author = htmlspecialchars(stripslashes($comment->comment_author));
			$comment_author_url =stripslashes($comment->comment_author_url);
			$comment_total = (int) $comment->comment_total;
				if ($comment_author_url) {
					$comment_author_link = "<a href='$comment_author_url' target='_blank'>$comment_author</a>";
				} else {
					$comment_author_link = "<a href='mailto:$comment_author_email'>$comment_author</a>";
				}
                                
			echo get_avatar($email, 40) . "<p><a href=\"$comment_author_url\" target=\"_blank\">$comment_author</a></p><p>已经发表了 $comment_total  条评论</p>";
			$no++;

			if($comment_total <= $threshhold && $threshhold != -1) {
				return;
			}
    }
}
?>